Index: /trunk/ICeCoffEE/ICeCoffEE/APEMain.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/APEMain.m	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/APEMain.m	(revision 142)
@@ -130,5 +130,4 @@
             ICCF_PatchMethod("TermSubview", "ICeCoffEETerminal", "ICECoffEETermSubviewSuper", "mouseUp:") &&
             ICCF_PatchMethod("TermSubview", "ICeCoffEETerminal", "ICECoffEETermSubviewSuper", "draggingEntered:") &&
-            ICCF_PatchMethod("TermSubview", "ICeCoffEETerminal", "ICECoffEETermSubviewSuper", "draggingExited:") &&
             ICCF_PatchMethod("TermSubview", "ICeCoffEETerminal", "ICECoffEETermSubviewSuper", "_optionClickEvent:::") ,
             ICapeprintf("ICeCoffEE APE: loaded in TermSubview for Terminal!\n");
@@ -190,4 +189,21 @@
 }
 
+void ICCF_GetCFTypePref(CFStringRef prefKey, CFTypeRef *val, CFTypeID type) {
+    if (*val != NULL) {
+        CFRelease(*val);
+        *val = NULL;
+    }
+    
+    *val = CFPreferencesCopyAppValue(prefKey, kICBundleIdentifier);
+
+    if (*val == NULL) return;
+
+    if (CFGetTypeID(*val) != type) {
+        CFRelease(*val);
+        *val = NULL;
+        return;
+    }
+}
+
 // to test: defaults write net.sabi.ICeCoffEE "Excluded Applications" -array '{CFBundleID = "com.apple.projectbuilder"; }' '{CFBundleID = "net.sabi.Pester"; }' '{CFBundleID = "com.apple.foobar"; }'
 static void ICCF_MigratePrefs() {
@@ -230,5 +246,5 @@
                 excludedAppBundle = CFBundleCreate(NULL, excludedAppURL);
                 if (excludedAppBundle != NULL) {
-                    APEToolsAddToExcludeList(kICBundleIdentifier, excludedAppBundle);
+                    APEToolsAddToExcludeList(kICBundleIdentifier, excludedAppBundle, CFSTR("Migrated from ICeCoffEE 1.0-1.2"), NO);
                 } else postponeMigrationForApp = YES; // can't create bundle
             } else postponeMigrationForApp = YES; // can't find app
@@ -256,4 +272,6 @@
     ICCF_prefs.servicesInContextualMenu = ICCF_GetBooleanPref(kICServicesInContextualMenu, YES);
     ICCF_prefs.servicesInMenuBar = ICCF_GetBooleanPref(kICServicesInMenuBar, NO);
+    ICCF_GetCFTypePref(kICServiceOptions, (CFTypeRef *)&ICCF_prefs.serviceOptions, CFDictionaryGetTypeID());
+    ICCF_prefs.terminalRequireOptionForSelfDrag = ICCF_GetBooleanPref(kICTerminalRequireOptionForSelfDrag, NO);
     ICCF_prefs.errorSoundEnabled = ICCF_GetBooleanPref(kICErrorSoundEnabled, NO);
     ICCF_prefs.errorDialogEnabled = ICCF_GetBooleanPref(kICErrorDialogEnabled, YES);
Index: /trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/classes.nib
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/classes.nib	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/classes.nib	(revision 142)
@@ -5,8 +5,10 @@
             ACTIONS = {
                 commandClickEnabled = id; 
+                editContextualServices = id; 
                 errorDialogEnabled = id; 
                 errorSoundEnabled = id; 
                 servicesInContextualMenu = id; 
                 servicesInMenuBar = id; 
+                terminalRequireOptionForSelfDrag = id; 
                 textBlinkCount = id; 
                 textBlinkEnabled = id; 
@@ -16,4 +18,5 @@
             OUTLETS = {
                 commandClickEnabled = NSButton; 
+                editContextualServices = NSButton; 
                 errorDialogEnabled = NSButton; 
                 errorSoundEnabled = NSButton; 
@@ -21,4 +24,5 @@
                 servicesInMenuBar = NSButton; 
                 tabView = NSTabView; 
+                terminalRequireOptionForSelfDrag = NSButton; 
                 textBlinkCount = NSPopUpButton; 
                 textBlinkEnabled = NSButton; 
Index: /trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/info.nib
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/info.nib	(revision 141)
+++ /trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/info.nib	(revision 142)
@@ -29,5 +29,5 @@
 	</array>
 	<key>IBSystem Version</key>
-	<string>6I32</string>
+	<string>6L60</string>
 	<key>IBUserGuides</key>
 	<dict>
Index: /trunk/ICeCoffEE/ICeCoffEE/English.lproj/Select services.nib/classes.nib
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/English.lproj/Select services.nib/classes.nib	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/English.lproj/Select services.nib/classes.nib	(revision 142)
@@ -0,0 +1,24 @@
+{
+    IBClasses = (
+        {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
+        {
+            CLASS = ICeCoffEENonHighlightingOutlineView; 
+            LANGUAGE = ObjC; 
+            SUPERCLASS = NSOutlineView; 
+        }, 
+        {
+            CLASS = ICeCoffEEServiceDataSource; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {serviceOutline = NSOutlineView; }; 
+            SUPERCLASS = NSObject; 
+        }, 
+        {
+            ACTIONS = {cancel = id; hideAll = id; saveChanges = id; showAll = id; }; 
+            CLASS = ICeCoffEEServicePrefController; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {serviceOutline = NSOutlineView; }; 
+            SUPERCLASS = NSWindowController; 
+        }
+    ); 
+    IBVersion = 1; 
+}
Index: /trunk/ICeCoffEE/ICeCoffEE/English.lproj/Select services.nib/info.nib
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/English.lproj/Select services.nib/info.nib	(revision 142)
+++ /trunk/ICeCoffEE/ICeCoffEE/English.lproj/Select services.nib/info.nib	(revision 142)
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IBDocumentLocation</key>
+	<string>99 33 356 240 0 0 1280 832 </string>
+	<key>IBFramework Version</key>
+	<string>291.0</string>
+	<key>IBOpenObjects</key>
+	<array>
+		<integer>21</integer>
+	</array>
+	<key>IBSystem Version</key>
+	<string>6L60</string>
+</dict>
+</plist>
